
#include "main.h"
#include "struct_3d.h"
#include "camera.h"
#include "3dmode.h"

extern bool gravity;

/*
float piover180 = 0.01745f;

void Camera::Rotate(float angle, float x, float y, float z)
{
	point3_t new_dir;

	// Get the view vector (The direction we are facing)
	point3_t view = direction - position;		

	// Calculate the sine and cosine of the angle once
	float cosTheta = (float)cos(angle);
	float sinTheta = (float)sin(angle);

	// Find the new x position for the new rotated point
	new_dir.x  = (cosTheta + (1 - cosTheta) * x * x)		* view.x;
	new_dir.x += ((1 - cosTheta) * x * y - z * sinTheta)	* view.y;
	new_dir.x += ((1 - cosTheta) * x * z + y * sinTheta)	* view.z;

	// Find the new y position for the new rotated point
	new_dir.y  = ((1 - cosTheta) * x * y + z * sinTheta)	* view.x;
	new_dir.y += (cosTheta + (1 - cosTheta) * y * y)		* view.y;
	new_dir.y += ((1 - cosTheta) * y * z - x * sinTheta)	* view.z;

	// Find the new z position for the new rotated point
	new_dir.z  = ((1 - cosTheta) * x * z - y * sinTheta)	* view.x;
	new_dir.z += ((1 - cosTheta) * y * z + x * sinTheta)	* view.y;
	new_dir.z += (cosTheta + (1 - cosTheta) * z * z)		* view.z;

	// Now we just add the newly rotated vector to our position to set
	// our new rotated view of our camera.
	direction = position + new_dir;

	/*
	float temp;

	angle_x -= speed;
	temp = angle_x;

	if (angle_x > 360)
		angle_x = (temp - 360);

	if (angle_x < 0)
		angle_x = 360 + temp;
		*/
/*
}

void Camera::Move(float speed)
{
	//position.x += (float)cos((360-angle_x)*piover180) * speed;
	//position.y += (float)sin((360-angle_x)*piover180) * speed;

	// Get the current view vector (the direction we are looking)
	point3_t view = direction - position;
	view = view.normalize();

	position.x += view.x * speed;		// Add our acceleration to our position's X
	position.y += view.y * speed;		// Add our acceleration to our position's Y
	position.z += view.z * speed;		// Add our acceleration to our position's Z
	direction.x += view.x * speed;		// Add our acceleration to our view's X
	direction.y += view.y * speed;		// Add our acceleration to our view's Y
	direction.z += view.z * speed;		// Add our acceleration to our view's Z
}

void Camera::Strafe(float speed)
{
	//position.x += (float)sin(angle_x*piover180) * speed;
	//position.y += (float)cos(angle_x*piover180) * speed;
}

void Camera::Tilt(float speed)
{
	angle_y += speed;

	if (angle_y > 80)
		angle_y = 80;

	if (angle_y < -80)
		angle_y = -80;
}

void Camera::Look()
{
	//glRotatef(270, 1.0f, 0.0f, 0.0f);
	//glRotatef(angle_y, 1.0f, 0.0f, 0.0f);
	//glRotatef(angle_x + 90, 0.0f, 0.0f, 1.0f);
	//glTranslatef(-position.x, -position.y, -position.z);
	gluLookAt(position.x, position.y, position.z, direction.x, direction.z, direction.y, 0.0f, 0.0f, 1.0f);
}

void Camera::SetPosition(point3_t pos)
{
	position.set(pos);
}

void Camera::SetAngle(float angle)
{
	angle_x = angle;
}
*/

Camera::Camera()
{
	position.set(0.0f, 0.0f, 0.0f);
	view.set(0.0f, 1.0f, 0.5f);
	up_vector.set(0.0f, 0.0f, 1.0f);
}

void Camera::PositionCamera(float pos_x,	float pos_y,	float pos_z,
			 				float view_x,	float view_y,	float view_z,
							float up_x,		float up_y,		float up_z)
{
	position.set(pos_x, pos_y, pos_z);
	view.set(view_x, view_y, view_z);
	up_vector.set(up_x, up_y, up_z);
}

/*
void CCamera::SetViewByMouse()
{
	POINT mousePos;									// This is a window structure that holds an X and Y
	int middleX = vid_width  >> 1;					// This is a binary shift to get half the width
	int middleY = vid_height >> 1;					// This is a binary shift to get half the height
	float angleY = 0.0f;							// This is the direction for looking up or down
	float angleZ = 0.0f;							// This will be the value we need to rotate around the Y axis (Left and Right)
	static float currentRotX = 0.0f;
	
	// Get the mouse's current X,Y position
	GetCursorPos(&mousePos);						
	
	// If our cursor is still in the middle, we never moved... so don't update the screen
	if( (mousePos.x == middleX) && (mousePos.y == middleY) ) return;

	// Set the mouse position to the middle of our window
	SetCursorPos(middleX, middleY);							

	// Get the direction the mouse moved in, but bring the number down to a reasonable amount
	angleY = (float)( (middleX - mousePos.x) ) / 500.0f;		
	angleZ = (float)( (middleY - mousePos.y) ) / 500.0f;		

	// Here we keep track of the current rotation (for up and down) so that
	// we can restrict the camera from doing a full 360 loop.
	currentRotX -= angleZ;  

	// If the current rotation (in radians) is greater than 1.0, we want to cap it.
	if(currentRotX > 1.5f)
		currentRotX = 1.5f;
	// Check if the rotation is below -1.0, if so we want to make sure it doesn't continue
	else if(currentRotX < -1.5f)
		currentRotX = -1.5f;
	// Otherwise, we can rotate the view around our position
	else
	{
		// To find the axis we need to rotate around for up and down
		// movements, we need to get a perpendicular vector from the
		// camera's view vector and up vector.  This will be the axis.
		CVector3 vAxis = Cross(m_vView - m_vPosition, m_vUpVector);
		vAxis = Normalize(vAxis);

		// Rotate around our perpendicular axis and along the y-axis
		RotateView(angleZ, vAxis.x, vAxis.y, vAxis.z);
		RotateView(angleY, 0, 1, 0);
	}
}
*/

void Camera::RotateView(float angle, float x, float y, float z)
{
	point3_t new_view;

	// Get the view vector (The direction we are facing)
	point3_t v_view = view - position;		

	// Calculate the sine and cosine of the angle once
	float cosTheta = (float)cos(angle);
	float sinTheta = (float)sin(angle);

	// Find the new x position for the new rotated point
	new_view.x  = (cosTheta + (1 - cosTheta) * x * x)		* v_view.x;
	new_view.x += ((1 - cosTheta) * x * y - z * sinTheta)	* v_view.y;
	new_view.x += ((1 - cosTheta) * x * z + y * sinTheta)	* v_view.z;

	// Find the new y position for the new rotated point
	new_view.y  = ((1 - cosTheta) * x * y + z * sinTheta)	* v_view.x;
	new_view.y += (cosTheta + (1 - cosTheta) * y * y)		* v_view.y;
	new_view.y += ((1 - cosTheta) * y * z - x * sinTheta)	* v_view.z;

	// Find the new z position for the new rotated point
	new_view.z  = ((1 - cosTheta) * x * z - y * sinTheta)	* v_view.x;
	new_view.z += ((1 - cosTheta) * y * z + x * sinTheta)	* v_view.y;
	new_view.z += (cosTheta + (1 - cosTheta) * z * z)		* v_view.z;

	// Now we just add the newly rotated vector to our position to set
	// our new rotated view of our camera.
	view = position + new_view;
}


void Camera::StrafeCamera(float speed)
{	
	// Add the strafe vector to our position
	position.x += strafe.x * speed;
	position.y += strafe.y * speed;

	// Add the strafe vector to our view
	view.x += strafe.x * speed;
	view.y += strafe.y * speed;
}

void Camera::MoveCamera(float speed)
{
	// Get the current view vector (the direction we are looking)
	point3_t vector = view - position;
	vector.set(vector.normalize());

	position.x += vector.x * speed;		// Add our acceleration to our position's X
	position.y += vector.y * speed;		// Add our acceleration to our position's Y

	if (!gravity)
		position.z += vector.z * speed;		// Add our acceleration to our position's Z

	view.x += vector.x * speed;			// Add our acceleration to our view's X
	view.y += vector.y * speed;			// Add our acceleration to our view's Y

	if (!gravity)
		view.z += vector.z * speed;			// Add our acceleration to our view's Z
}

void Camera::Update() 
{
	// Initialize a variable for the cross product result
	point3_t v_cross = cross(view - position, up_vector);

	// Normalize the strafe vector
	strafe = v_cross.normalize();
}

void Camera::Look()
{
	// Give openGL our camera position, then camera view, then camera up vector
	gluLookAt(position.x, position.y, position.z,	
			  view.x,	 view.y,     view.z,	
			  up_vector.x, up_vector.y, up_vector.z);
}