
// Main includes
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string>
using std::string;

#ifdef WIN32
#include <windows.h>
#endif

// External libraries
#include "SDL.h"
#include "SDL_opengl.h"
//#include "GL/gl.h"
//#include "GL/glu.h"
#include "IL/il.h"
#include "IL/ilu.h"

// Define min and max for compilers that don't have them
#ifndef max
#define max(a,b) (((a)>(b))?(a):(b))
#endif
#ifndef min
#define min(a,b) (((a)<(b))?(a):(b))
#endif

// Program source headers
#include "defines.h"
#include "structs.h"
#include "texture_list.h"
#include "memreader.h"
#include "cvar.h"
#include "colours.h"
#include "render.h"

// Function definitions
bool init_opengl();
void read_line(FILE *f, char *string);
void message_box(string message);
void print(bool debug, char *message, ...);
void text_ui();
void text_welcome();
bool init();
string bool2yesno(bool value);
string str_upper(string str);