// <<--------------------------------------------->>
// << SLADE (SlayeR's 'LeetAss Doom Editor)       >>
// << By Simon Judd, 2004-05                      >>
// << ------------------------------------------- >>
// << <misc.cpp>                                  >>
// << Stuff that doesn't go anywhere else :P      >>
// <<--------------------------------------------->>

// Includes ------------------------------------- >>
#include "main.h"
#include <math.h>

// insertion_sort: Sorts an array of integers using the 'insertion sort' method
// ------------------------------------------------------------------------- >>
void insertion_sort(int* a, int low, int high)
{
	for (int p = low + 1; p <= high; p++)
	{
		int tmp = a[p];
		int j;

		for (j = p; j > low && tmp < a[j - 1]; j--)
			a[j] = a[j - 1];

		a[j] = tmp;
	}
}

// swap: Swaps two integer references
// ------------------------------- >>
void swap(int* first, int* second)
{
	int tmp = *first;

	*first = *second;
	*second = tmp;
}

// quick_sort: Sorts an array of integers using the 'quick sort' method
// ----------------------------------------------------------------- >>
void quick_sort(int* a, int low, int high)
{
	if (low + 10 > high)
		insertion_sort(a, low, high);
	else
	{
		int middle = (low + high) / 2;
		if (a[middle] < a[low])
			swap(&a[low], &a[middle]);
		if (a[high] < a[low])
			swap(&a[low], &a[high]);
		if (a[high] < a[middle])
			swap(&a[middle], &a[high]);

		swap(&a[middle], &a[high - 1]);
		int pivot = a[high - 1];

		int i, j;
		for (i = low; j = high - 1; )
		{
			while (a[++i] < pivot) ;
			while (pivot < a[--j]) ;
			if (i >= j)
				break;
			swap(&a[i], &a[j]);
		}

		swap(&a[i], &a[high - 1]);
		quick_sort(a, low, i - 1);
		quick_sort(a, i + 1, high);
	}
}

// magnitude_2d: Gets the magnitude of a 2d vector
// -------------------------------------------- >>
float magnitude_2d(point2_t point)
{
	return (float)sqrt(float((point.x * point.x) + (point.y * point.y)));
}

// strupr: Converts a char* string to uppercase
// ----------------------------------------- >>
char *strupr( char *String )
{
	char *Help = String ;

	for ( ; *Help != '\0' ; ++Help)
		if (islower ((unsigned char) *Help))
			*Help = (char) toupper ((unsigned char) *Help) ;

	return (String) ;
}
